#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

$lock_tables = "false"; ### true / false

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use Time::Local; 
use File::Copy;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

if ($q->param('fct') eq "download") {&download;}


print "Content-type: text/html\n\n";
if ($q->param('fct') eq "backup") {&backup_text;}
if ($q->param('fct') eq "prepare_backup") {&prepare_backup;}
if ($q->param('fct') eq "continueb") {&continueb;}
if ($q->param('fct') eq "dobackup") {&dobackup;}
if ($q->param('fct') eq "restore") {&restore;} ## CONFIRM RESTORE
if ($q->param('fct') eq "restore1") {&restore1;} ## CLEAR DB REDIRECT
if ($q->param('fct') eq "restore2") {&restore2;} ## CLEAR DB
if ($q->param('fct') eq "restore3") {&restore3;} ## CLEAR DB

if ($q->param('fct') eq "pathinfo") {&pathinfo;} ## CLEAR DB



##################################################################################


sub pathinfo
{

$idcheck = `2>&1 which mysql`;

print "Mysql: $idcheck<BR>";


}




sub restore3
{

### GET mysqldump CONFIGURATION
$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);
$mysqlp = $allditems[2];


### CONSTRUCT SYSTEM COMMAND
$mysqlp = $mysqlp . " -u $db_username -p" . $db_password . " ";

	if ($mysql_hostname ne "")
		{
		$remote_host_crit = "--host=" . $mysql_hostname . " ";
		}

	if ($mysql_port ne "")
		{
		$remote_host_crit = $remote_host_crit . "--port=" . $mysql_port . " ";
		}

$exec_m = "$mysqlp $remote_host_crit $db_name < $data_dir/dbbackup/backup.sql";
$idcheck = `2>&1 $exec_m`;



$ldata = &get_file_contents("$data_dir/dbbackup/keys.dat"); 
open (BKEY, "> $data_dir/keys.dat");
	print BKEY $ldata;
close (BKEY);
chmod($default_permissions,"$data_dir/keys.dat","$data_dir/keys.dat");



if ($idcheck ne "")
	{

$hbox = acs::get_heading_box("$web_url/ic_restore.gif", "Problem Restoring Data", qq[
<a href="$admin_url/admin43.cgi">Click Here to Continue</a>
]);	
	
print qq[
<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox

<table border="0" width="100%" cellspacing="1" cellpadding="6"
style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="100%" class="normaltext">It looks like the restore was not successfull. The
    following was reported when trying to execute the mysql program to restore the data from: <br>
    <strong>$data_dir/dbbackup/$dbname.sql </strong><blockquote>
      <p>$idcheck </p>
    </blockquote>
    <p>The following parameters was passed on to the mysql &nbsp; program to restore the data:
    <br>
    <strong>$exec_m</strong></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

</body>
</html>
];
	}
	else
	{

$hbox = acs::get_heading_box("$web_url/ic_restore.gif", "Data Restored", qq[
<a href="$admin_url/admin43.cgi">Click Here to Continue</a>
]);

print qq[
<html>
<head>
<title>PowerSeek SQL</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];	
	
	}



}




sub restore2
{

#if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
#$dbh = DBI->connect($dsn, $db_username, $db_password);
#if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

#$sth = $dbh->prepare("SHOW TABLES");
#$sth->execute;
#$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
#$tcount = 0;

#$tc = 0;
#while ( @row = $sth->fetchrow() )
#	{
#	if ($row[0] eq "ppc_links"){$ppc_links = "true";}
#	$tables_to_clear[$tc] = $row[0];
#	$tc++;
#	}
	

#foreach $item (@tables_to_clear)
#	{
#	$sql = "DELETE FROM $item";
#	$sth = $dbh->prepare($sql);
#	$sth->execute;
#	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
#	}

#$sth->finish;
#$dbh->disconnect;


print qq[
<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin52.cgi?fct=restore3">
</head>
<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/ic_restore.gif"></td>
    <td width="99%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Restoring
    Data</strong></font><p><img src="$web_url/working.gif"></p>
    <p><strong><font face="Verdana" size="1">Please Wait...</font></strong><br>
    </td>
  </tr>
</table>

</body>
</html>
];


}



sub restore1
{

$hbox = acs::get_heading_box("$web_url/ic_restore.gif", "Restoring...", qq[
<img src="$web_url/working.gif"> <BR>
<b>Please Wait...</b>
]);


print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin52.cgi?fct=restore3">
</head>
<body>
$hbox
</body>
</html>

];





}






sub restore
{

### FIRST CHECK IF BACKUP IS CONFIGURED

$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);
$mysqlp = $allditems[2];

if ($allditems[0] ne "mysqldump")
	{
	$error_text = "The backup program is not configured. To configure it go to the PowerSeek Control Panel >> Plug-Ins >> Data Backups >> Configure";
	}


if ((-e "$allditems[1]") < 1)
	{
	$error_text = "The backup program is not configured. To configure it go to the PowerSeek Control Panel >> Plug-Ins >> Data Backups >> Configure";
	}

if ((-e "$allditems[2]") < 1)
	{
	$error_text = "The backup program is not configured. To configure it go to the PowerSeek Control Panel >> Plug-Ins >> Data Backups >> Configure";
	}




if ($error_text ne "")
	{

$hbox = acs::get_heading_box("$web_url/ic_backup2.gif", "Problem", qq[
The backup utillity is not configured. <a href="$admin_url/admin43.cgi?fct=conf"><strong>Click here to configure it.</strong></a>
]);

	
print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>
$hbox
</body>
</html>
];
exit;
	
	}





$fsize = (-s "$data_dir/dbbackup/backup.sql");
$fsize = substr($fsize, 0, length($fsize) - 3);



$hbox = acs::get_heading_box("$web_url/ic_restore.gif", "Problem", qq[

 <font color="#000000">The restore program will </font>
 <font color="#FF0000">delete all data in the existing database</font>
 <font color="#000000"> and restore data to the database from the backup file:<br>
    <strong>$data_dir/dbbackup/backup.sql</strong> (Size: $fsize k)</font>
    
<p><font color="#FF0000">Make sure that <strong><br>
    $data_dir/dbbackup/backup.sql<br>
    </strong>contains the data that you want to restore to the database. </font>
</p><p><strong>Restore data now? <a  href="$admin_url/admin52.cgi?fct=restore1">Yes</a> | <a href="$admin_url/admin43.cgi">No</a></strong>

]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox
</body>
</html>
];


}



sub download
{
copy("$data_dir/dbbackup/backup.sql","$web_dir/$db_name.sql") or die "Copy failed: $!";
print "Location: $web_url/$db_name.sql\n\n";
}







sub dobackup
{

### GET NUMBER OF RECORDS IN FILES FOR BACKUP FILE VERIFICATION LATER ON

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

$sql = "SELECT COUNT(*) FROM dirs";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
while ( @row = $sth->fetchrow() ){ $dirs = $row[0]; }

$sql = "SELECT COUNT(*) FROM links";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
while ( @row = $sth->fetchrow() ){ $total_links = $row[0]; }

$sth->finish;
$dbh->disconnect;


### GET mysqldump CONFIGURATION
$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);
$mysqldump = $allditems[1];


### CONSTRUCT SYSTEM COMMAND
$mysqlp = $mysqlp . " -u $db_username -p" . $db_password . " ";

	if ($mysql_hostname ne "")
		{
		$remote_host_crit = "--host=" . $mysql_hostname . " ";
		}

	if ($mysql_port ne "")
		{
		$remote_host_crit = $remote_host_crit . "--port=" . $mysql_port . " ";
		}


if ($lock_tables eq "true"){ $addlocks = "--add-locks"; }

#$exec_m = "$mysqldump -u $db_username -p$db_password $db_name $remote_host_crit --quick --no-create-info --complete-insert $addlocks > $data_dir/dbbackup/$db_name.sql";
$exec_m = "$mysqldump -u $db_username -p$db_password $db_name $remote_host_crit --quick --add-drop-table --complete-insert $addlocks > $data_dir/dbbackup/backup.sql";
#print "Executing: $exec_m <BR><BR>";


if (-e "$data_dir/dbbackup/$db_name.sql")
	{
	chmod($default_permissions,"$data_dir/dbbackup/$db_name.sql","$data_dir/dbbackup/backup.sql");
	}




$idcheck = `2>&1 $exec_m`;
#print ($idcheck, "<BR>\n"); 
#$idcheck = "fsdfsd";

if ($idcheck ne "")
	{
	
$hbox = acs::get_heading_box("$web_url/ic_backup2.gif", "Problem", qq[

<p>It looks like the backup was not successfull. The following was reported when trying to   execute mysqldump to dump the whole database into the text file: <br>
  <strong>$data_dir/dbbackup/backup.sql </strong></p>
<blockquote>
  <p>$idcheck </p>
</blockquote>
<p>The following parameters was passed on to the mysqldump program to make the backup: <br>
    <strong>$exec_m </strong></p>

<a href="$admin_url/admin43.cgi">Click Here to Continue</a>
]);
	
print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

];
	
	}
	else
	{

	
$ldata = &get_file_contents("$data_dir/keys.dat"); 
open (BKEY, "> $data_dir/dbbackup/keys.dat");
	print BKEY $ldata;
close (BKEY);
chmod($default_permissions,"$data_dir/dbbackup/keys.dat","$data_dir/dbbackup/keys.dat");


$hbox = acs::get_heading_box("$web_url/ic_backup2.gif", "Backup Complete", qq[

<p><strong>Download Backup File </strong><br>
By downloading the backup file you will download the backed up contents of your
database. Note that the file has been placed at: <br>
<b>$data_dir/dbbackup/backup.sql </b><br>
and will be available there if you would like to restore the database. We recommend that
you keep a local copy on your hard drive or other medium so that you have a backup
readilly available in unforseen circumstances. 
<ul>
  <li><strong><a href="$admin_url/admin52.cgi?fct=download" class="normaltext">Click here if you would like to
    download the backup file (Right Click and Choose 'Save as')</a></strong></li>
</ul>
<a href="$admin_url/admin43.cgi">Click Here to Continue</a>
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>

];


	}

#### 




}





sub continueb
{


$hbox = acs::get_heading_box("$web_url/ic_backup2.gif", "Creating Backup", qq[
<img src="$web_url/working.gif"><BR>
Please Wait...
]);


print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin52.cgi?fct=dobackup">
</head>
<body>
$hbox
</body>
</html>

];

}




sub backup_text
{

### FIRST CHECK IF BACKUP IS CONFIGURED

$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);
$mysqlp = $allditems[2];

if ($allditems[0] ne "mysqldump")
	{
	$error_text = "The backup program is not configured. To configure it go to the PowerSeek Control Panel >> Plug-Ins >> Data Backups >> Configure";
	}


if ((-e "$allditems[1]") < 1)
	{
	$error_text = "The backup program is not configured. To configure it go to the PowerSeek Control Panel >> Plug-Ins >> Data Backups >> Configure";
	}

if ((-e "$allditems[2]") < 1)
	{
	$error_text = "The backup program is not configured. To configure it go to the PowerSeek Control Panel >> Plug-Ins >> Data Backups >> Configure";
	}


if ($error_text ne "")
	{



$hbox = acs::get_heading_box("$web_url/ic_backup2.gif", "Problem", qq[
The backup utillity is not configured. <a href="$admin_url/admin43.cgi?fct=conf"><strong>Click here to configure it.</strong></a>
]);

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];
exit;
	
	}
	

$hbox = acs::get_heading_box("$web_url/ic_backup2.gif", "Backup", qq[

<strong><font color="#FF0000">Caution: </font></strong>Please do not use the MySQL database that you are using for PowerSeek with third
    party applications. When you restore the PowerSeek backup the data of the<font
    color="#FF0000"><strong> third party applications will be lost.</strong></font>
<BR><BR>

<a href="$admin_url/admin52.cgi?fct=prepare_backup"><strong>Click Here to make a backup of your PowerSeek Data</strong></a>

]);



print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}












sub prepare_backup
{


if ((-e "$data_dir/dbbackup") < 1)
	{ 
	mkdir ("$data_dir/dbbackup", $default_permissions);
	chmod($default_permissions,"$data_dir/dbbackup","$data_dir/dbbackup");
	}

opendir(DIR,"$data_dir/dbbackup");
@files = readdir(DIR);

foreach $filename (@files)
	{
	if (($filename ne ".") and ($filename ne ".."))
		{
		$fsize = (-s "$data_dir/dbbackup/$filename");
		$fsize = substr($fsize, 0, length($fsize) - 3);
		if ($fsize eq "") { $fsize = 0; }
		$allfiles = $allfiles . "$data_dir/dbbackup/$filename - Size: $fsize k<br>";
		}
	}

if ($allfiles ne "")
{

$hbox = acs::get_heading_box("$web_url/ic_backup2.gif", "Preparing Data Backup", qq[

<font color="#000000"><strong>The following backup files where found in the backup directory:</strong></font><br>
<font color="#8080FF"><strong>$allfiles</strong></font>

<p><font color="#FF8000"><strong>These files will be removed and replaced by the new backup files.</strong></font></p>
<p><strong>Would you like to continue? <a href="$admin_url/admin52.cgi?fct=continueb">Yes</a> | <a href="$admin_url/admin43.cgi">No</a></strong>
]);

print <<END_OF_CONTIN;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
$hbox
</body>
</html>

END_OF_CONTIN

}
else
{

print <<END_OF_DBB;

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin52.cgi?fct=dobackup">
</head>
<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Backing
    Up Data</strong></font><p><img src="$web_url/working.gif"></p>
    <p><strong><font face="Verdana" size="1">Please Wait...</font></strong><br>
    </td>
  </tr>
</table>

</body>
</html>

END_OF_DBB
}



}

 



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

